#include "ti86asm.inc"
#include "ti86ops.inc"
.org _asm_exec_ram
	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Trig Identities",0
Title:
	.db " Trig Identities  - By Adam Martin",0
keys:
	.db "      ",6,"  ",7," move    ENTER   select    EXIT   quits",0
line1:
	.db " Reciprocal   Identities",0
line2:
	.db " Quotient   Identities",0
line3:
	.db " Pythagorean   Identities",0
line4:
	.db " Cofunction   Identities",0
line5:
	.db " Even - Odd   Identities",0
line6:
	.db " Double - Angle   Identities",0
Recip1:
	.db " sin x = 1/(csc x)",0
Recip2:
	.db " sec x = 1/(cos x)",0
Recip3:
	.db " tan x = 1/(cot x)",0
Recip4:
	.db " csc x = 1/(sin x)",0
Recip5:
	.db " cos x = 1/(sec x)",0
Recip6:
	.db " cot x = 1/(tan x)",0
Q1:
	.db " tan x = (sin x)/(cos x)",0
Q2:
	.db " cot x = (cos x)/(sin x)",0
Pythag1:
	.db " sin",Lsquare," x   +   cos",Lsquare," x = 1",0
Pythag2:
	.db " 1   +   tan",Lsquare," x = sec",Lsquare," x",0
Pythag3:
	.db " 1   +   cot",Lsquare," x = csc",Lsquare," x",0
Cof1:
	.db " sin (",Lpi,"/2 - x) = cos x",0
Cof2: 
	.db " cos (",Lpi,"/2 - x) = sin x",0
Cof3:
	.db " csc (",Lpi,"/2 - x) = sec x",0
Cof4:
	.db " tan (",Lpi,"/2 - x) = cot x",0
Cof5:
	.db " sec (",Lpi,"/2 - x) = csc x",0
Cof6:
	.db " cot (",Lpi,"/2 - x) = tan x",0
EO1:
	.db " sin(-x) = -sin x",0   
EO2:
	.db " cos(-x) = cos x",0
EO3:
	.db " csc(-x) = -csc x",0
EO4:
	.db " tan(-x) = -tan x",0
EO5:	
	.db " sec(-x) = sec x",0
EO6:
	.db " cot(-x) = -cot x",0
DA1:
	.db " sin 2x = 2 sin x cos x",0
DA2:
	.db " cos 2x = cos",Lsquare," x - sin",Lsquare," x ",0
DA3:
	.db " cos",Lsquare," x - sin",Lsquare," x = 2 cos",Lsquare," x - 1",0
DA4:
	.db " 2 cos",Lsquare," x - 1 = 1 - 2 sin",Lsquare," x",0
DA5
	.db " tan 2x = (2 tan x)/(1 - tan",Lsquare," x)",0
PressEnter:
	.db "                                 "
	.db "        Press   Enter !",0
ProgStart:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,Title
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,line1
	call _vputs
	ld hl,$0E00
	ld (_penCol),hl
	ld hl,line2
	call _vputs
	ld hl,$1500
	ld (_penCol),hl
	ld hl,line3
	call _vputs
	ld hl,$1C00
	ld (_penCol),hl
	ld hl,line4
	call _vputs
	ld hl,$2300
	ld (_penCol),hl
	ld hl,line5
	call _vputs
	ld hl,$2A00
	ld (_penCol),hl
	ld hl,line6
	call _vputs
	ld hl,$3900
	ld (_penCol),hl
	ld hl,keys
	call _vputs
	call B7Black
	ld c,6
DoMenuDTL:
	ld a,d								;Get The Vertical Coord
	add a,7								;Move To Next Line
	ld d,a								;Save New Coord
	djnz DoMenuDTL						;Draw All The Text
	ld b,1								;Start Menu At First Entry
	call DoMenuInvBar					;Invert It
DoMenuL:
	push bc								;Save Entries And Current Entry
	call _getky						 	;Read Key Presses
	pop bc								;Restore It
	cp K_UP								;Did They Press Up?
	jr z,DoMenuUp						;Move Menu Bar Up
	cp K_EXIT
	jp z,Exit
	cp K_DOWN							;Or Was It Down?
	jr z,DoMenuDown
	cp K_ENTER
	jr z,WhichIdentity
	jr DoMenuL							;They're Just Sitting There, Loop Again
DoMenuUp:
	call DoMenuInvBar					;Invert Current Selection Back To Normal
	dec b								;Move Up
	jr nz,DoMenuBar
	ld b,6
	jr DoMenuBar						;Handle Menu Bar
DoMenuDown:
	call DoMenuInvBar					;Same As Up, Go Back To Normal Text
	ld a,c
	cp b								;At The Bottom?
	jr z,DoMenuDownT					;Then Move To The Top								;Get Current Entry For Check
	inc b								;Move Down
	jr DoMenuBar						;Handle Menu Bar
DoMenuDownT:
	ld b,1								;Move To The Top
DoMenuBar:
	call DoMenuInvBar					;Invert The New Selection
	jr DoMenuL							;Now It's Time To Loop
DoMenuInvBar:
	push bc								;Save Position And Entries
	ld h,b								;Get Position
	ld l,112							;There Are 7 Lines Of 16 Bytes Each (7*16 = 112)
	call _HtimesL						;Do The Multiply
	ld de,$fc00 							;We Need To Add To Video Memory
	add hl,de							;Do The Add
	call DoMenuInv						;Invert The Line
	pop bc								;Restore Position And Entries
	ret									;Done Inverting
DoMenuInv:
	ld b,7*16							;Each Row Is 16 Bytes Wide And Text Is 7 Rows High
DoMenuIL:
	ld a,(hl)							;Get The Byte
	cpl						 			;NOT The Byte--Flips All The Bits
	ld (hl),a							;Save The New Byte
	inc hl								;Next Byte
	djnz DoMenuIL						;Loop For All Bytes
	ret						 			;We're Done With The Invert Loop
Exit:
	call _clrLCD
	call _homeup
	ret
Top7Invert:
	call _clrLCD
	ld   hl,$FC00
    ld   (hl),$FF
    ld   de,$FC01
    ld   bc,111
    ldir
    set  3,(iy+05)
    ld   de,$0001
    ld   (_penCol),de
    ret
Drw:
    call _vputs
    res  3,(iy+05)
	ret
B7Black:
    ld b,112
    ld hl,$FF90
Draw1:
    ld a,(hl)
    cpl
    ld (hl),a
    inc	hl
    djnz Draw1
	ret
WhichIdentity:
	ld a,1
	cp b
	jp z,Reciprocal
	inc a
	cp b
	jp z,Quotient
	inc a
	cp b
	jp z,Pythagorean
	inc a
	cp b
	jp z,Cofunction
	inc a
	cp b
	jp z,EvenOdd
	jp nz,DblAngles
Reciprocal:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line1
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Recip1
	call _vputs
	ld hl,$0E00
	ld (_penCol),hl
	ld hl,Recip2
	call _vputs
	ld hl,$1500
	ld (_penCol),hl
	ld hl,Recip3
	call _vputs
	ld hl,$1C00
	ld (_penCol),hl
	ld hl,Recip4
	call _vputs
	ld hl,$2300
	ld (_penCol),hl
	ld hl,Recip5
	call _vputs
	ld hl,$2A00
	ld (_penCol),hl
	ld hl,Recip6
	call _vputs
	ld hl,$3900
	ld (_penCol),hl
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
Quotient:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line2
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Q1
	call _vputs
	ld hl,$0E00
	ld (_penCol),hl
	ld hl,Q2
	call _vputs
	ld hl,$3900
	ld (_penCol),hl
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
Pythagorean:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line3
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Pythag1
	call _vputs
	ld hl,$0E00
	ld (_penCol),hl
	ld hl,Pythag2
	call _vputs
	ld hl,$1500
	ld (_penCol),hl
	ld hl,Pythag3
	call _vputs
	ld hl,$3900
	ld (_penCol),hl
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
Cofunction:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line4
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Cof1
	call _vputs
	ld hl,$0E00
	ld (_penCol),hl
	ld hl,Cof2
	call _vputs
	ld hl,$1500
	ld (_penCol),hl
	ld hl,Cof3
	call _vputs
	ld hl,$1C00
	ld (_penCol),hl
	ld hl,Cof4
	call _vputs
	ld hl,$2300
	ld (_penCol),hl
	ld hl,Cof5
	call _vputs
	ld hl,$2A00
	ld (_penCol),hl
	ld hl,Cof6
	call _vputs
	ld hl,$3900
	ld (_penCol),hl
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
EvenOdd:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line5
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,EO1
	call _vputs
	ld hl,$0E00
	ld (_penCol),hl
	ld hl,EO2
	call _vputs
	ld hl,$1500
	ld (_penCol),hl
	ld hl,EO3
	call _vputs
	ld hl,$1C00
	ld (_penCol),hl
	ld hl,EO4
	call _vputs
	ld hl,$2300
	ld (_penCol),hl
	ld hl,EO5
	call _vputs
	ld hl,$2A00
	ld (_penCol),hl
	ld hl,EO6
	call _vputs
	ld hl,$3900
	ld (_penCol),hl
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
DblAngles: 
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line6
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,DA1
	call _vputs
	ld hl,$0E00
	ld (_penCol),hl
	ld hl,DA2
	call _vputs
	ld hl,$1500
	ld (_penCol),hl
	ld hl,DA3
	call _vputs
	ld hl,$1C00
	ld (_penCol),hl
	ld hl,DA4
	call _vputs
	ld hl,$2300
	ld (_penCol),hl
	ld hl,DA5
	call _vputs
	ld hl,$3900
	ld (_penCol),hl
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
.message "Trig Identities By Adam Martin"
.end
